/*
 * 机具申请明细
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MachineApplyDetailController : BaseController
    {
        public MachineApplyDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具申请明细列表

        /// <summary>
        /// 根据条件查询机具申请明细列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MachineApplyDetail data, string right, string ApplyId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ApplyId = ApplyId;


            string Condition = "";
            Condition += "ApplyNo:\"" + data.ApplyNo + "\",";
Condition += "ProductType:\"" + data.ProductType + "\",";
Condition += "DeviceStatus:\"" + data.DeviceStatus + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询机具申请明细列表

        /// <summary>
        /// 机具申请明细列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MachineApplyDetail data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ApplyId", "1");

            Fields.Add("ApplyNo", "2"); //订单号
Fields.Add("CreateDate", "3"); //时间
Fields.Add("ProductType", "1"); //实际发货产品类型
Fields.Add("DeviceStatus", "1"); //设备状态

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineApplyDetail", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具申请明细

        /// <summary>
        /// 增加或修改机具申请明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string ApplyId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ApplyId = ApplyId;


            return View();
        }

        #endregion

        #region 增加机具申请明细

        /// <summary>
        /// 增加或修改机具申请明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MachineApplyDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ApplyId", data.ApplyId);

            Fields.Add("ProductType", data.ProductType); //实际发货产品类型
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MachineApplyDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "MachineApplyDetail", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改机具申请明细

        /// <summary>
        /// 增加或修改机具申请明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string ApplyId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ApplyId = ApplyId;


            MachineApplyDetail editData = db.MachineApplyDetail.FirstOrDefault(m => m.Id == Id) ?? new MachineApplyDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具申请明细

        /// <summary>
        /// 增加或修改机具申请明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MachineApplyDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ApplyId", data.ApplyId);

            Fields.Add("ProductType", data.ProductType); //实际发货产品类型
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineApplyDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MachineApplyDetail","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除机具申请明细信息

        /// <summary>
        /// 删除机具申请明细信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MachineApplyDetail","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineApplyDetail", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MachineApplyDetail","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineApplyDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MachineApplyDetail","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineApplyDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MachineApplyDetail", Sort, Id);
            
            AddSysLog(Id.ToString(), "MachineApplyDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.MachineApplyDetail.Add(new MachineApplyDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "MachineApplyDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MachineApplyDetail data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ApplyNo", "2"); //订单号
Fields.Add("CreateDate", "3"); //时间
Fields.Add("ProductType", "1"); //实际发货产品类型
Fields.Add("DeviceStatus", "1"); //设备状态

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineApplyDetail", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MachineApplyDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
